﻿

{ *** OP_Code_01 *** }



  procedure OP_Code_01;
  var
    quell_reg, ziel_reg, temp2_byte_reg : Byte;
    quell_string : String;
  begin

    // HALT
    if OP_Code = $76 then begin

      Befehl_Zeile := 'HALT';


      {$IFDEF mit_GUI}

        Form_EMUZ80.Memo_Protokoll.Lines.Add('*** Abarbeitung gestoppt');

        // *****************************************
        Mode_Protokoll:=true;
        Form_EMUZ80.EMU_Mode_Trace:=false;
        Form_EMUZ80.EMU_Mode_Run:=false;

      {$ENDIF}


      Befehl_abgearbeitet:=true;

    end
    else begin

      quell_reg :=  OP_Code AND %00000111;
      quell_string:='???';

      case quell_reg of

        // LD r, A
        %00000111 : begin
                      temp2_byte_reg := mod_cpu.Reg.HRS.A;
                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin
                        quell_string:='A';
                        Form_cpu.Reg_Red.HRS.A:=Farbe_Lesen;
                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                    end; // LD r, A


        // LD r, B
        %00000000 : begin
                      temp2_byte_reg := mod_cpu.Reg.HRS.B;
                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin
                        quell_string:='B';
                        Form_cpu.Reg_Red.HRS.B:=Farbe_Lesen;
                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                    end; // LD r, B


        // LD r, C
        %00000001 : begin
                      temp2_byte_reg := mod_cpu.Reg.HRS.C;
                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin
                        quell_string:='C';
                        Form_cpu.Reg_Red.HRS.C:=Farbe_Lesen;
                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                    end; // LD r, C


        // LD r, D
        %00000010 : begin
                      temp2_byte_reg := mod_cpu.Reg.HRS.D;
                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin
                        quell_string:='D';
                        Form_cpu.Reg_Red.HRS.D:=Farbe_Lesen;
                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                    end; // LD r, D


        // LD r, E
        %00000011 : begin
                      temp2_byte_reg := mod_cpu.Reg.HRS.E;
                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin
                        quell_string:='E';
                        Form_cpu.Reg_Red.HRS.E:=Farbe_Lesen;
                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                    end; // LD r, E


        // LD r, H
        %00000100 : begin
                      temp2_byte_reg := mod_cpu.Reg.HRS.H;
                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin
                        quell_string:='H';
                        Form_cpu.Reg_Red.HRS.H:=Farbe_Lesen;
                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                    end; // LD r, H

        // LD r, L
        %00000101 : begin
                      temp2_byte_reg := mod_cpu.Reg.HRS.L;
                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin
                        quell_string:='L';
                        Form_cpu.Reg_Red.HRS.L:=Farbe_Lesen;
                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                    end; // LD r, L


        // LD r, (HL)
        %00000110 : begin
                      temp2_byte_reg := mod_ram.Read_Byte((mod_cpu.Reg.HRS.H shl 8) + mod_cpu.Reg.HRS.L);
                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin
                        quell_string:='(HL)';
                        Form_RAM.setze_Mem_Green((mod_cpu.Reg.HRS.H shl 8) + mod_cpu.Reg.HRS.L);
                        Form_cpu.Reg_Red.HRS.HL_Inhalt:=Farbe_Lesen;
                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                    end; // LD r, (HL)


      end; { case quell_reg of }


      ziel_reg :=  OP_Code AND %00111000;

      case ziel_reg of
        // LD A, r
        %00111000 : begin
                      mod_cpu.Reg.HRS.A := temp2_byte_reg;

                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin

                        Befehl_Zeile := 'LD A,'+quell_string;

                        Form_cpu.Reg_Red.HRS.A:=Farbe_Schreiben;

                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                      Befehl_abgearbeitet:=true;

                    end; // // LD A, r


        // LD B, r
        %00000000 : begin
                      mod_cpu.Reg.HRS.B := temp2_byte_reg;

                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin

                        Befehl_Zeile := 'LD B, '+quell_string;

                        Form_cpu.Reg_Red.HRS.B:=Farbe_Schreiben;

                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                      Befehl_abgearbeitet:=true;

                    end; // // LD B, r

        // LD C, r
        %00001000 : begin
                      mod_cpu.Reg.HRS.C := temp2_byte_reg;

                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin

                        Befehl_Zeile := 'LD C, '+quell_string;

                        Form_cpu.Reg_Red.HRS.C:=Farbe_Schreiben;

                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                      Befehl_abgearbeitet:=true;

                    end; // // LD C, r

        // LD D, r
        %00010000 : begin
                      mod_cpu.Reg.HRS.D := temp2_byte_reg;

                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin

                        Befehl_Zeile := 'LD D, '+quell_string;

                        Form_cpu.Reg_Red.HRS.D:=Farbe_Schreiben;

                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                      Befehl_abgearbeitet:=true;

                    end; // // LD D, r

        // LD E, r
        %00011000 : begin
                      mod_cpu.Reg.HRS.E := temp2_byte_reg;

                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin

                        Befehl_Zeile := 'LD E, '+quell_string;

                        Form_cpu.Reg_Red.HRS.E:=Farbe_Schreiben;

                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                      Befehl_abgearbeitet:=true;

                    end; // // LD E, r

        // LD H, r
        %00100000 : begin
                      mod_cpu.Reg.HRS.H := temp2_byte_reg;

                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin

                        Befehl_Zeile := 'LD H, '+quell_string;

                        Form_cpu.Reg_Red.HRS.H:=Farbe_Schreiben;

                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                      Befehl_abgearbeitet:=true;

                    end; // // LD H, r

        // LD L, r
        %00101000 : begin
                      mod_cpu.Reg.HRS.L := temp2_byte_reg;

                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin

                        Befehl_Zeile := 'LD L, '+quell_string;

                        Form_cpu.Reg_Red.HRS.L:=Farbe_Schreiben;

                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                      Befehl_abgearbeitet:=true;

                    end; // // LD L, r

        // LD (HL), r
        %00110000 : begin
                      mod_ram.Write_Byte((mod_cpu.Reg.HRS.H shl 8) + mod_cpu.Reg.HRS.L, temp2_byte_reg);

                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin

                        Befehl_Zeile := 'LD (HL), '+quell_string;

                        Form_RAM.setze_Mem_Red((mod_cpu.Reg.HRS.H shl 8) + mod_cpu.Reg.HRS.L);
                        Form_cpu.Reg_Red.HRS.HL_Inhalt:=Farbe_Schreiben;

                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                      Befehl_abgearbeitet:=true;

                    end; // // LD (HL), r


      end; { case quell_reg of }

    end; { if OP_Code = $76 then }

  end; { procedure OP_Code_01 }




